#include <stdio.h>
#include <stdlib.h>

#ifdef F128
#include <quadmath.h>
#endif

#include "type.h"

char fbuf[FBUFSIZE];

char * fstr(MYFLOAT x) {
  
#ifdef F128
    quadmath_snprintf (fbuf, sizeof(fbuf), "%+-#*.28Qe", QUADWIDTH, x);
    return fbuf;
#endif

#ifdef F80
    snprintf(fbuf, sizeof(fbuf), "%+-#*.28Lf", LDWIDTH, x);
    return fbuf;
#endif

#ifdef F64
    snprintf(fbuf, sizeof(fbuf), "%+-#*.22lf", DWIDTH, x);
    return fbuf;
#endif


#ifdef F32
    snprintf(fbuf, sizeof(fbuf), "%+-#*.16f", FWIDTH, x);
    return fbuf;
#endif

  snprintf(fbuf, sizeof(fbuf), "fstr(): BAD CONVERSION");
  return fbuf;
}

int readf(const char *str, MYFLOAT *x) {
#ifdef F128
  if (sizeof(*x) == sizeof(__float128)) {
    *x = strtoflt128(str, NULL);
    return 1;
  }
#endif

#ifdef F80
  if (sizeof(*x) == sizeof(long double)) {
    sscanf(str, "%Lf", x);
    return 1;
  }
#endif

#ifdef F64
  if (sizeof(*x) == sizeof(double)) {
    sscanf(str, "%lf", x);
    return 1;
  }
#endif
  
#ifdef F32
  if (sizeof(*x) == sizeof(float)) {
    sscanf(str, "%f", x);
    return 1;
  }
#endif
  
  return 0;
}
